/* rygel-tracker-pictures.c generated by valac 0.44.9, the Vala compiler
 * generated from rygel-tracker-pictures.vala, do not modify */

/*
 * Copyright (C) 2009 Nokia Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <rygel-server.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#define RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER (rygel_tracker_category_container_get_type ())
#define RYGEL_TRACKER_CATEGORY_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER, RygelTrackerCategoryContainer))
#define RYGEL_TRACKER_CATEGORY_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER, RygelTrackerCategoryContainerClass))
#define RYGEL_TRACKER_IS_CATEGORY_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER))
#define RYGEL_TRACKER_IS_CATEGORY_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER))
#define RYGEL_TRACKER_CATEGORY_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER, RygelTrackerCategoryContainerClass))

typedef struct _RygelTrackerCategoryContainer RygelTrackerCategoryContainer;
typedef struct _RygelTrackerCategoryContainerClass RygelTrackerCategoryContainerClass;
typedef struct _RygelTrackerCategoryContainerPrivate RygelTrackerCategoryContainerPrivate;

#define RYGEL_TRACKER_TYPE_ITEM_FACTORY (rygel_tracker_item_factory_get_type ())
#define RYGEL_TRACKER_ITEM_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_ITEM_FACTORY, RygelTrackerItemFactory))
#define RYGEL_TRACKER_ITEM_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_ITEM_FACTORY, RygelTrackerItemFactoryClass))
#define RYGEL_TRACKER_IS_ITEM_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_ITEM_FACTORY))
#define RYGEL_TRACKER_IS_ITEM_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_ITEM_FACTORY))
#define RYGEL_TRACKER_ITEM_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_ITEM_FACTORY, RygelTrackerItemFactoryClass))

typedef struct _RygelTrackerItemFactory RygelTrackerItemFactory;
typedef struct _RygelTrackerItemFactoryClass RygelTrackerItemFactoryClass;

#define RYGEL_TRACKER_TYPE_PICTURES (rygel_tracker_pictures_get_type ())
#define RYGEL_TRACKER_PICTURES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_PICTURES, RygelTrackerPictures))
#define RYGEL_TRACKER_PICTURES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_PICTURES, RygelTrackerPicturesClass))
#define RYGEL_TRACKER_IS_PICTURES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_PICTURES))
#define RYGEL_TRACKER_IS_PICTURES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_PICTURES))
#define RYGEL_TRACKER_PICTURES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_PICTURES, RygelTrackerPicturesClass))

typedef struct _RygelTrackerPictures RygelTrackerPictures;
typedef struct _RygelTrackerPicturesClass RygelTrackerPicturesClass;
typedef struct _RygelTrackerPicturesPrivate RygelTrackerPicturesPrivate;
enum  {
	RYGEL_TRACKER_PICTURES_0_PROPERTY,
	RYGEL_TRACKER_PICTURES_NUM_PROPERTIES
};
static GParamSpec* rygel_tracker_pictures_properties[RYGEL_TRACKER_PICTURES_NUM_PROPERTIES];

#define RYGEL_TRACKER_TYPE_PICTURE_ITEM_FACTORY (rygel_tracker_picture_item_factory_get_type ())
#define RYGEL_TRACKER_PICTURE_ITEM_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_PICTURE_ITEM_FACTORY, RygelTrackerPictureItemFactory))
#define RYGEL_TRACKER_PICTURE_ITEM_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_PICTURE_ITEM_FACTORY, RygelTrackerPictureItemFactoryClass))
#define RYGEL_TRACKER_IS_PICTURE_ITEM_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_PICTURE_ITEM_FACTORY))
#define RYGEL_TRACKER_IS_PICTURE_ITEM_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_PICTURE_ITEM_FACTORY))
#define RYGEL_TRACKER_PICTURE_ITEM_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_PICTURE_ITEM_FACTORY, RygelTrackerPictureItemFactoryClass))

typedef struct _RygelTrackerPictureItemFactory RygelTrackerPictureItemFactory;
typedef struct _RygelTrackerPictureItemFactoryClass RygelTrackerPictureItemFactoryClass;
#define _rygel_tracker_item_factory_unref0(var) ((var == NULL) ? NULL : (var = (rygel_tracker_item_factory_unref (var), NULL)))

#define RYGEL_TRACKER_TYPE_METADATA_CONTAINER (rygel_tracker_metadata_container_get_type ())
#define RYGEL_TRACKER_METADATA_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_METADATA_CONTAINER, RygelTrackerMetadataContainer))
#define RYGEL_TRACKER_METADATA_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_METADATA_CONTAINER, RygelTrackerMetadataContainerClass))
#define RYGEL_TRACKER_IS_METADATA_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_METADATA_CONTAINER))
#define RYGEL_TRACKER_IS_METADATA_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_METADATA_CONTAINER))
#define RYGEL_TRACKER_METADATA_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_METADATA_CONTAINER, RygelTrackerMetadataContainerClass))

typedef struct _RygelTrackerMetadataContainer RygelTrackerMetadataContainer;
typedef struct _RygelTrackerMetadataContainerClass RygelTrackerMetadataContainerClass;

#define RYGEL_TRACKER_TYPE_METADATA_VALUES (rygel_tracker_metadata_values_get_type ())
#define RYGEL_TRACKER_METADATA_VALUES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_METADATA_VALUES, RygelTrackerMetadataValues))
#define RYGEL_TRACKER_METADATA_VALUES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_METADATA_VALUES, RygelTrackerMetadataValuesClass))
#define RYGEL_TRACKER_IS_METADATA_VALUES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_METADATA_VALUES))
#define RYGEL_TRACKER_IS_METADATA_VALUES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_METADATA_VALUES))
#define RYGEL_TRACKER_METADATA_VALUES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_METADATA_VALUES, RygelTrackerMetadataValuesClass))

typedef struct _RygelTrackerMetadataValues RygelTrackerMetadataValues;
typedef struct _RygelTrackerMetadataValuesClass RygelTrackerMetadataValuesClass;

#define RYGEL_TRACKER_TYPE_YEARS (rygel_tracker_years_get_type ())
#define RYGEL_TRACKER_YEARS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TRACKER_TYPE_YEARS, RygelTrackerYears))
#define RYGEL_TRACKER_YEARS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TRACKER_TYPE_YEARS, RygelTrackerYearsClass))
#define RYGEL_TRACKER_IS_YEARS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TRACKER_TYPE_YEARS))
#define RYGEL_TRACKER_IS_YEARS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TRACKER_TYPE_YEARS))
#define RYGEL_TRACKER_YEARS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TRACKER_TYPE_YEARS, RygelTrackerYearsClass))

typedef struct _RygelTrackerYears RygelTrackerYears;
typedef struct _RygelTrackerYearsClass RygelTrackerYearsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _RygelTrackerCategoryContainer {
	RygelSimpleContainer parent_instance;
	RygelTrackerCategoryContainerPrivate * priv;
	RygelTrackerItemFactory* item_factory;
};

struct _RygelTrackerCategoryContainerClass {
	RygelSimpleContainerClass parent_class;
};

struct _RygelTrackerPictures {
	RygelTrackerCategoryContainer parent_instance;
	RygelTrackerPicturesPrivate * priv;
};

struct _RygelTrackerPicturesClass {
	RygelTrackerCategoryContainerClass parent_class;
};

static gpointer rygel_tracker_pictures_parent_class = NULL;

GType rygel_tracker_category_container_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerCategoryContainer, g_object_unref)
gpointer rygel_tracker_item_factory_ref (gpointer instance);
void rygel_tracker_item_factory_unref (gpointer instance);
GParamSpec* rygel_tracker_param_spec_item_factory (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void rygel_tracker_value_set_item_factory (GValue* value,
                                           gpointer v_object);
void rygel_tracker_value_take_item_factory (GValue* value,
                                            gpointer v_object);
gpointer rygel_tracker_value_get_item_factory (const GValue* value);
GType rygel_tracker_item_factory_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerItemFactory, rygel_tracker_item_factory_unref)
GType rygel_tracker_pictures_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerPictures, g_object_unref)
RygelTrackerPictures* rygel_tracker_pictures_new (const gchar* id,
                                                  RygelMediaContainer* parent,
                                                  const gchar* title);
RygelTrackerPictures* rygel_tracker_pictures_construct (GType object_type,
                                                        const gchar* id,
                                                        RygelMediaContainer* parent,
                                                        const gchar* title);
RygelTrackerPictureItemFactory* rygel_tracker_picture_item_factory_new (void);
RygelTrackerPictureItemFactory* rygel_tracker_picture_item_factory_construct (GType object_type);
GType rygel_tracker_picture_item_factory_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerPictureItemFactory, rygel_tracker_item_factory_unref)
RygelTrackerCategoryContainer* rygel_tracker_category_container_construct (GType object_type,
                                                                           const gchar* id,
                                                                           RygelMediaContainer* parent,
                                                                           const gchar* title,
                                                                           RygelTrackerItemFactory* item_factory);
RygelTrackerYears* rygel_tracker_years_new (RygelMediaContainer* parent,
                                            RygelTrackerItemFactory* item_factory);
RygelTrackerYears* rygel_tracker_years_construct (GType object_type,
                                                  RygelMediaContainer* parent,
                                                  RygelTrackerItemFactory* item_factory);
GType rygel_tracker_metadata_container_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerMetadataContainer, g_object_unref)
GType rygel_tracker_metadata_values_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerMetadataValues, g_object_unref)
GType rygel_tracker_years_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelTrackerYears, g_object_unref)
void rygel_tracker_category_container_add_create_class (RygelTrackerCategoryContainer* self,
                                                        const gchar* create_class);

RygelTrackerPictures*
rygel_tracker_pictures_construct (GType object_type,
                                  const gchar* id,
                                  RygelMediaContainer* parent,
                                  const gchar* title)
{
	RygelTrackerPictures * self = NULL;
	RygelTrackerPictureItemFactory* _tmp0_;
	RygelTrackerPictureItemFactory* _tmp1_;
	RygelTrackerItemFactory* _tmp2_;
	RygelTrackerYears* _tmp3_;
	RygelTrackerYears* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	_tmp0_ = rygel_tracker_picture_item_factory_new ();
	_tmp1_ = _tmp0_;
	self = (RygelTrackerPictures*) rygel_tracker_category_container_construct (object_type, id, parent, title, (RygelTrackerItemFactory*) _tmp1_);
	_rygel_tracker_item_factory_unref0 (_tmp1_);
	_tmp2_ = ((RygelTrackerCategoryContainer*) self)->item_factory;
	_tmp3_ = rygel_tracker_years_new ((RygelMediaContainer*) self, _tmp2_);
	_tmp4_ = _tmp3_;
	rygel_simple_container_add_child_container ((RygelSimpleContainer*) self, (RygelMediaContainer*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = rygel_searchable_container_get_search_classes ((RygelSearchableContainer*) self);
	_tmp6_ = _tmp5_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, RYGEL_IMAGE_ITEM_UPNP_CLASS);
	rygel_tracker_category_container_add_create_class ((RygelTrackerCategoryContainer*) self, RYGEL_IMAGE_ITEM_UPNP_CLASS);
	return self;
}

RygelTrackerPictures*
rygel_tracker_pictures_new (const gchar* id,
                            RygelMediaContainer* parent,
                            const gchar* title)
{
	return rygel_tracker_pictures_construct (RYGEL_TRACKER_TYPE_PICTURES, id, parent, title);
}

static void
rygel_tracker_pictures_class_init (RygelTrackerPicturesClass * klass,
                                   gpointer klass_data)
{
	rygel_tracker_pictures_parent_class = g_type_class_peek_parent (klass);
}

static void
rygel_tracker_pictures_instance_init (RygelTrackerPictures * self,
                                      gpointer klass)
{
}

/**
 * Container listing Pictures content hierarchy.
 */
GType
rygel_tracker_pictures_get_type (void)
{
	static volatile gsize rygel_tracker_pictures_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_tracker_pictures_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelTrackerPicturesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_tracker_pictures_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelTrackerPictures), 0, (GInstanceInitFunc) rygel_tracker_pictures_instance_init, NULL };
		GType rygel_tracker_pictures_type_id;
		rygel_tracker_pictures_type_id = g_type_register_static (RYGEL_TRACKER_TYPE_CATEGORY_CONTAINER, "RygelTrackerPictures", &g_define_type_info, 0);
		g_once_init_leave (&rygel_tracker_pictures_type_id__volatile, rygel_tracker_pictures_type_id);
	}
	return rygel_tracker_pictures_type_id__volatile;
}

